#!/usr/local/bin/perl
##############################################################################
# Bannermaster Ad Rotaion Engine (bm_admin.cgi)                              #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The Bannermaster engine, including all files in the origninal distribution #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
##############################################################################

   $VERSION="1.23";
   $PROGRAM="Bannermaster Admin";

   require ("iweb.pm");
   &parse_form;

  #### Buttons and HTML file locations
  $manual = $html_dir."/bm_manual.htm";

  #### What are we doing ???
  $action = $input{'action'};
  $password = $input{'password'};


  ### If not readonly, or password is ok, do the right thing...
  if ($action eq "admin") { &bm_admin; }
  if ($action eq "menu")   {&nav_bar;}

  ## Group Management Stuff
    if ($action eq "Define Groups") {&Define_Groups;}
    if ($action eq "Save Groups") {&Save_Groups;}
    if ($action eq "Update Group Record") {&Save_Group_Changes;}
    if ($action eq "Group Manager") {&Group_Manager;}

  ## Account Management Stuff
    if ($action eq "Add Account") {&Add_Account;}
    if ($action eq "Save New Account") {&Save_New_Account;}

    if ($action eq "List Accounts") {&List_Accounts;}
    if ($action eq "Edit") {&Edit_Account;}
    if ($action eq "Save Account Modification") {&Save_Account_Modification;}
    if ($action eq "Stats") {&Account_Stats;}
    if ($action eq "Delete") {&Delete_Account;}
    if ($action eq "Disable") {&Disable_Account;}
    if ($action eq "Re-Enable") {&Enable_Account;}
    if ($action eq "Re-Initialize") {&Init_Account;}


sub Define_Groups {

    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);

    for $x (0 .. $#groups) {
       $group_list .= $groups[$x];
    }
    $group_list =~ s/\cM//g;


    print "Content-Type: text/html\n\n";
    print <<DONE;

    <BODY BGCOLOR="$pg_color" TEXT="$text_color">
    <BR><BR><CENTER>
    <FORM ACTION="bm_admin.cgi">
    <TABLE BORDER=1><TR><TD>
      <TABLE BORDER=0><TR BGCOLOR="$title_color"><TD>
        <FONT COLOR="$ttxt_color"><B>Group Listing...</B></FONT></TD></TR>
        <TR BGCOLOR="$win_color"><TD>
        <TEXTAREA NAME="group_list" ROWS=12 COLS=40>$group_list</TEXTAREA>
        <BR><BR>
        <CENTER><INPUT NAME="action" TYPE="submit" VALUE="Save Groups">
      </TD></TR></TABLE>
    </TD></TR></TABLE>
    </FORM>
    </BODY>

DONE
   
    exit 0;     

}



sub Save_Groups {

    $group_list = $input{'group_list'};

    open("GRP",">$data_dir/groups/groups.def");
      $group_list =~ s/\cM//g;
      $group_list =~ s/ /\_/g;
      print GRP $group_list;
    close(GRP);

    @groups = split(/\n/,$group_list);
    for $x (0 .. $#groups) {
      if (! -e "$data_dir/groups/$groups[$x].grp") {
         open("FILE","> $data_dir/groups/$groups[$x].grp");
         close(FILE);
      }
    }

    $ok_msg = "Group Listing Saved.";
    $click="self.location.href='bm_admin.cgi?action=Define+Groups'";

    &ok_box($ok_message,$click);
}




sub Save_Group_Changes {

   $AccountList = $input{'account'};
   $AccountList =~ s/ /\n/g;
   $group = $input{'group'};


   open("FILE","> $data_dir/groups/$group.grp");
     print FILE "$AccountList";
   close(FILE);

   &Group_Manager;

}



sub Group_Manager {

    $group = $input{'group'};

    open ("ACT", "$data_dir/groups/accounts.list") || &ERROR("Cannot Read Accounts File!");
      @accounts = <ACT>;
    close(ACT);


   print "Content-Type: text/html\n\n";
   print "<CENTER><H1>Group Manager</H1>\n";

       open("GRPFILE","$data_dir/groups/$group.grp") || &ERROR("$! : $data_dir/groups/$group.grp ");
          @lines = <GRPFILE>;
       close(GRPFILE);
       
       print "<FORM ACTION=\"bm_admin.cgi\">\n";
       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD COLSPAN=3><FONT COLOR=\"$ttxt_color\"><B>$groups[$x]</B></FONT></TD></TR>\n";
       print "<TR BGCOLOR=\"$win_color\">\n";
       
       $Columns = 0;
       for $y(0 .. $#accounts) {
          $accounts[$y] =~ s/\n//g;
          print "<TD><FONT COLOR=\"$text_color\">\n";
          ### Now see if it needs to be checked...
          $exists="F";
          for $z(0 .. $#lines) {
             $lines[$z] =~ s/\n//g;
             if ($lines[$z] =~ $accounts[$y]) { $exists="T"; }
          }

          if ($exists eq "T") {
                print "<INPUT TYPE=\"checkbox\" NAME=\"account\" VALUE=\"$accounts[$y]\" CHECKED>$accounts[$y]\n";
          }
          else {
                print "<INPUT TYPE=\"checkbox\" NAME=\"account\" VALUE=\"$accounts[$y]\">$accounts[$y]\n";
          }

          print "</FONT></TD>\n";
          $Count++;
          if ($Count >= 3) { 
             $Count = 0;
             print "</TR><TR BGCOLOR=\"$win_color\">\n"; 
          }
       }
       print "</TD></TR><TR BGCOLOR=\"$win_color\"><TD COLSPAN=3>\n";
       print "<INPUT NAME=\"group\" TYPE=\"hidden\" VALUE=\"$group\">\n";
       print "<CENTER><INPUT NAME=\"action\" TYPE=\"submit\" VALUE=\"Update Group Record\">\n";
       print "</TD></TR></TABLE></TD></TR></TABLE><BR><BR>\n";
       print "</CENTER><BLOCKQUOTE>\n";
       print <<DONE;

       Check the box next to each account name to add this account to the rotation for this group.
       <BR><BR>
       **YooHoo Users:  This will tie the accounts to the categories in your engine.
         If your advertisers don't match any of the categories specifically, or if they
         have not purchased "targeted" ads from you, then you may select the "All" account
         as well, to include this banner in the rotation for all YooHoo! pages.

DONE

   exit 0;

}


sub Add_Account {

   print "Content-Type: text/html\n\n";

   print <<DONE;

    <BODY BGCOLOR="$pg_color" TEXT="$text_color">
    <BR><BR><CENTER>
    <FORM ACTION="bm_admin.cgi">
    <TABLE BORDER=1><TR><TD>
      <TABLE BORDER=0><TR BGCOLOR="$title_color"><TD>
        <FONT COLOR="$ttxt_color"><B>Add New Account...</B></FONT></TD></TR>
        <TR BGCOLOR="$win_color"><TD>
        <PRE>
     Account Name:   <INPUT NAME="acct_name">   
     Login ID:       <INPUT NAME="acct_login">
     Login Password: <INPUT NAME="acct_password">

     Target:         <SELECT NAME="target">
        <OPTION VALUE="_top">Top of Current Window
        <OPTION VALUE="_blank">Blank Window (Always a new one)
        <OPTION VALUE="new">New Window (Re-use same)
        </SELECT>

     Redirect URL:   <INPUT NAME="redirect_url">
     ALT Text:       <INPUT NAME="alt_text">
     "Under Text"    <INPUT NAME="under_text">

     Banner1 :       <INPUT NAME="banner">
               Size: <INPUT NAME="banner_width" SIZE=3 VALUE="468"> x <INPUT NAME="banner_height" SIZE=3 VALUE="60">

      (Enter just the filename, if the banner image is
       in the BANNERS directory.  If the banner is being
       pulled from your client's site, enter the full URL
       here, including the "http://...")

     <U>Account Paramaters</U>
     Campaign Type:  <SELECT NAME="expiration_type">
        <OPTION VALUE="clicks">Number of Clicks
        <OPTION VALUE="impressions">Number of Impressions
        <OPTION VALUE="date">Time Period
        </SELECT> 

        Max Clicks:       <INPUT NAME="num_clicks">
        Max Impressions:  <INPUT NAME="num_impressions">
        Date Range:       <INPUT NAME="start_date" SIZE=12> -> <INPUT NAME="end_date" SIZE=12>
           (Enter in mm/dd/yy format !!)

        Into which Groups should this Account be included?
           
DONE

    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);   

    for $x (0 .. $#groups) {
       $groups[$x] =~ s/\n//g;
       $groups[$x] =~ s/\cM//g;
       print "        <INPUT TYPE=\"checkbox\" NAME=\"group\" VALUE=\"$groups[$x]\">$groups[$x]\n";
    }

   print <<DONE1;
        </PRE>  
        <CENTER><INPUT NAME="action" TYPE="submit" VALUE="Save New Account"></CENTER>
      </TD></TR></TABLE>
    </TD></TR></TABLE>
    </FORM>
    </BODY>


DONE1

   exit 0;


}


sub Save_New_Account {

    ### Values from input...
    $acct_name       = $input{'acct_name'};
       $acct_name =~ s/ /_/g;

    $acct_login      = $input{'acct_login'};
    $acct_password   = $input{'acct_password'};
    $target          = $input{'target'};
    $redirect_url    = $input{'redirect_url'};
    $alt_text        = $input{'alt_text'};
    $under_text      = $input{'under_text'};
    $banner         = $input{'banner'};
    $banner_width   = $input{'banner_width'};
    $banner_height  = $input{'banner_height'};
    $expiration_type = $input{'expiration_type'};
    $num_clicks      = $input{'num_clicks'};
    $num_impressions = $input{'num_impressions'};
    $start_date      = $input{'start_date'};
    $end_date        = $input{'end_date'};
    $group           = $input{'group'};
       @groups = split(/ /,$group);


    $LINE .= $acct_name . "|";
    $LINE .= $acct_login . "|";
    $LINE .= $acct_password . "|";
    $LINE .= $target . "|";
    $LINE .= $redirect_url . "|";
    $LINE .= $alt_text . "|";
    $LINE .= $under_text . "|";
    $LINE .= $banner . "|";
    $LINE .= $banner_width . "|";
    $LINE .= $banner_height . "|";
    $LINE .= $expiration_type . "|";
    $LINE .= $num_clicks . "|";
    $LINE .= $num_impressions . "|";
    $LINE .= $start_date . "|";
    $LINE .= $end_date;


    ## Check and create directory for this account
    if ( ! -d "$data_dir/accounts/$acct_name" ) {
       mkdir "$data_dir/accounts/$acct_name",0777 || &ERROR("Cannot Make Account Directory!");
    }

    if ( ! -d "$data_dir/accounts/$acct_name/logs" ) {
       mkdir "$data_dir/accounts/$acct_name/logs",0777 || &ERROR("Cannot Make Logfile Directory!");
    }

    ## Create the account data file
    open ("NEW", ">$data_dir/accounts/$acct_name/$acct_name.dat") || &ERROR("Cannot Account Data File!");
       print NEW $LINE;
    close (NEW);

    ## Add a record to the accounts file
    $exists = "F";
    open ("ACT", "$data_dir/groups/accounts.list") || &ERROR("Cannot Read Accounts File!");
       @accounts = <ACT>;
    close(ACT);
    for $y (0 .. $#accounts) {
        if ($accounts[$y] =~ $acct_name) { $exists = "T"; }
    }
    if ($exists ne "T") { 
       open ("ACT1", ">>$data_dir/groups/accounts.list") || &ERROR("Cannot Append Accounts File!");
          print ACT1 "$acct_name\n";
       close (ACT1);
    }
 
    ## Update the relevant group files
    for $x( 0 .. $#groups ) {
       $GROUP = "$groups[$x].grp";
       $exists = "F";
       ## If the group file exists, make sure of no dups...then create/append to it
       if (-e "$data_dir/groups/$GROUP") {
          open ("DAT", "$data_dir/groups/$GROUP") || &ERROR("Cannot read $GROUP file!");
              @lines = <DAT>;
          close(DAT);
          for $y (0 .. $#lines) {
             if ($lines[$y] =~ $acct_name) { $exists = "T"; }
          }
       }

       if ($exists ne "T") {
          open ("GRP", ">>$data_dir/groups/$GROUP") || &ERROR("Cannot append to $GROUP file!");
             print GRP "$acct_name\n";
          close(GRP);
       }
    }


    print "Content-Type: text/html\n\n";
    print "Added.\n";

    exit 0;

}



##############################################################################
# List the categories and sub categories
##############################################################################
sub List_Accounts {

    open ("ACT", "$data_dir/groups/accounts.list") || &ERROR("Cannot Read Accounts File!");
      @accounts = <ACT>;
    close(ACT);

    print "Content-Type: text/html\n\n";

    print <<DONE;

    <BODY BGCOLOR="$pg_color" TEXT="$text_color">
    <BR><BR><CENTER>
    <TABLE BORDER=2 CELLPADDING=0 CELLSPACING=0><TR><TD>
      <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0><TR BGCOLOR="$title_color"><TD COLSPAN="6">
        <FONT COLOR="$ttxt_color"><B>Account Manager</B></FONT></TD></TR>
DONE

    for $x ( 0 .. $#accounts ) {
        $accounts[$x] =~ s/\n//g;
        print "<TR BGCOLOR=\"$win_color\">\n";
        print "<FORM ACTION=\"bm_admin.cgi\">\n";
        print "<TD><B>$accounts[$x]</B></TD>\n";
        print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Edit\"></TD>\n";
        print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Stats\"></TD>\n";
        print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Delete\"></TD>\n";

        if (-e "$data_dir/accounts/$accounts[$x]/DISABLED") {
           print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Re-Enable\"></TD>\n";
        }
        else {
           print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Disable\"></TD>\n";
        }
        print "<TD><CENTER><INPUT TYPE=\"SUBMIT\" NAME=\"action\" VALUE=\"Re-Initialize\"></TD>\n";
        print "<INPUT TYPE=\"HIDDEN\" NAME=\"acct_name\" VALUE=\"$accounts[$x]\"></FORM></TR>\n";
    }

    print "</TABLE>\n";
    print "</TD></TR></TABLE>\n";
    print "</BODY>\n";
    print "</HTML>\n";

    exit 0;


}



sub Edit_Account {


   $acct_name = $input{'acct_name'};

   open ("ACT", "$data_dir/accounts/$acct_name/$acct_name.dat") || &ERROR("Cannot Read Account Data File!");
      @lines = <ACT>;
   close(ACT);

   $lines[0] =~ s/\n//g;

   ($acct_name,$acct_login,$acct_password,$target,$redirect_url,$alt_text,$under_text,$banner,$banner_width,$banner_height,$expiration_type,$num_clicks,$num_impressions,$start_date,$end_date) = split(/\|/,$lines[0]);
  
   print "Content-Type: text/html\n\n";

   print <<DONE;

    <BODY BGCOLOR="$pg_color" TEXT="$text_color">
    <BR><BR><CENTER>
    <FORM ACTION="bm_admin.cgi">
    <TABLE BORDER=1><TR><TD>
      <TABLE BORDER=0><TR BGCOLOR="$title_color"><TD>
        <FONT COLOR="$ttxt_color"><B>Edit Account Paramaters...</B></FONT></TD></TR>
        <TR BGCOLOR="$win_color"><TD>
        <PRE>
     Account Name:   <INPUT NAME="acct_name" VALUE="$acct_name">   
     Login ID:       <INPUT NAME="acct_login" VALUE="$acct_login">
     Login Password: <INPUT NAME="acct_password" VALUE="$acct_password">

     Target:         <SELECT NAME="target">
        <OPTION VALUE="$target" SELECTED>$target
        <OPTION VALUE="_top">Top of Current Window
        <OPTION VALUE="_blank">Blank Window (Always a new one)
        <OPTION VALUE="new">New Window (Re-use same)
        </SELECT>

     Redirect URL:   <INPUT NAME="redirect_url" VALUE="$redirect_url">
     ALT Text:       <INPUT NAME="alt_text" VALUE="$alt_text">
     "Under Text"    <INPUT NAME="under_text" VALUE="$under_text">

     Banner :       <INPUT NAME="banner" VALUE="$banner">
               Size: <INPUT NAME="banner_width" SIZE=3 VALUE="$banner_width"> x <INPUT NAME="banner_height" SIZE=3 VALUE="$banner_height">

      (Enter just the filename, if the banner image is
       in the BANNERS directory.  If the banner is being
       pulled from your client's site, enter the full URL
       here, including the "http://...")

     <U>Account Paramaters</U>
     Campaign Type:  <SELECT NAME="expiration_type">
        <OPTION VALUE="$expiration_type" SELECTED>$expiration_type
        <OPTION VALUE="clicks">Number of Clicks
        <OPTION VALUE="impressions">Number of Impressions
        <OPTION VALUE="date">Time Period
        </SELECT> 

        Max Clicks:       <INPUT NAME="num_clicks" VALUE="$num_clicks">
        Max Impressions:  <INPUT NAME="num_impressions" VALUE="$num_impressions">
        Date Range:       <INPUT NAME="start_date" SIZE=12 VALUE="$start_date"> -> <INPUT NAME="end_date" SIZE=12 VALUE="$end_date">
           (Enter in mm/dd/yy format !!)

        This account belongs to the following group(s):
           
DONE

    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);   

    for $x (0 .. $#groups) {
       $groups[$x] =~ s/\n//g;
       $groups[$x] =~ s/\cM//g;

       $GROUP = "$groups[$x].grp";
       $exists = "F";

       open ("DAT", "$data_dir/groups/$GROUP");
           @lines = <DAT>;
       close(DAT);

       for $y (0 .. $#lines) {
          if ($lines[$y] =~ $acct_name) { $exists = "T"; }
       }
       if ($exists eq "T") { 
              print "        $groups[$x]\n";
       }

    }

   print <<DONE1;
        </PRE>  
        <CENTER><INPUT NAME="action" TYPE="submit" VALUE="Save Account Modification"></CENTER>
      </TD></TR></TABLE>
    </TD></TR></TABLE>
    </FORM>
    </BODY>


DONE1

   exit 0;

}


sub Account_Stats {

   $ACCOUNT = $input{'acct_name'};

   $imp_referer={};
   $clk_referer={};
   $totals={};

   $clk_count = 0;
   $tot_count = 0;
   $imp_count = 0;

   print "Content-Type: text/html\n\n";

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   $tot_file = "$data_dir/accounts/$ACCOUNT/$ACCOUNT.total";
   open("TOT1","$tot_file");
      @entries=<TOT1>;
   close(TOT1);
   $entries[0] =~ s/\n//g;
   @totals = split(/\|/,$entries[0]);
   $impressions = $totals[0];
   $clicks = $totals[1];


   $log_dir = "$data_dir/accounts/$ACCOUNT/logs";
   opendir(FILES, "$log_dir") || die ERROR("Can't open log directory ($log_dir) <BR><BR>");
     @filelist=readdir(FILES);
   closedir(FILES);

    for $z( 0 .. $#filelist ) {

        $file = $filelist[$z];
        $filebase = $filelist[$z];
        $date = $filelist[$z];
        $filebase =~ s/\.log//g;
        $filebase = "$data_dir/accounts/$ACCOUNT/logs/$filebase";
        $date =~ s/\.log//g;
        $date =~ s/_/\//g;

        if($file =~ /.*\.log/ ) {

           ### Tally the daily impressions ###
           open ("LOG","$filebase.log") || &ERROR("Cant open $filebase.log");
              @log=<LOG>;
           close(LOG);

           open ("CLK","$filebase.clicks");
              @clk=<CLK>;
           close(CLK);

           if ($#clk < 0) { $tot_clicks = 0; }
           else { $tot_clicks = $#clk + 1; }
           @{$totals[$tot_count++]}{qw( date impressions clicks )}=
             ( $date, $#log +1, $tot_clicks ); 

        }

    }
      
       $acct_name =~ s/_/ /g;
       print "<CENTER><H1>Advertising Report .... $acct_name</H1>\n";
       print "<H3>Grand Total: $impressions Impressions / $clicks Clicks\n";

          if ( $impressions <= 0 ) { $impressions = 1; }
          $pct = $clicks / $impressions;
          $pct = $pct*100;
          printf ("( %2.2f \% )\n", $pct);
        
       print "</H3>\n";
       print "<BLOCKQUOTE>\n";
       print "<H4>Daily Totals:</H4>\n";
       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Date</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Impressions</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Clicks</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">PCT</TD></TR>\n";

       for $t( 0 .. $#totals ) {
          $date = $totals[$t]{'date'};
          $date =~ s/\//_/g;
          $link = "report.cgi?account=$ACCOUNT&action=detail&date=$date&MODE=admin";
          print "<TR BGCOLOR=\"$win_color\">\n";
          print "<TD><center><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
          print "  <a href=\"$link\">$totals[$t]{'date'}</a></center></TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'impressions'}</TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'clicks'}</TD>\n";
 
          if ( $totals[$t]{'impressions'} <= 0 ) { $totals[$t]{'impressions'} = 1; }
          $pct = $totals[$t]{'clicks'} / $totals[$t]{'impressions'};
          $pct = $pct*100;
          if ($pct > 1.5) { $pct_color = "blue"; }
          elsif ($pct >= .6 ) { $pct_color = "$text_color"; }
          else { $pct_color="red"; }

          printf ("<TD><FONT FACE=\"$font_face\" COLOR=\"$pct_color\">%2.2f \%</TD></TR>\n", $pct);
       }
       print "</TABLE>\n";
       print "</TD></TR></TABLE>\n";


       exit 0;

}


sub Delete_Account {

   $acct_name = $input{'acct_name'};

   print "Content-Type: text/html\n\n";

   opendir(FILES, "$data_dir/accounts/$acct_name/logs");
     @allfiles=readdir(FILES);
   closedir(FILES);   

   for $x ( 0 .. $#allfiles ) {
      if ($allfiles[$x] =~ ".log") {
        unlink "$data_dir/accounts/$acct_name/logs/$allfiles[$x]";
        print "$data_dir/accounts/$acct_name/logs/$allfiles[$x] Deleted.<BR>\n"; 
      }
   }

   unlink "$data_dir/accounts/$acct_name/$acct_name.dat";
   unlink "$data_dir/accounts/$acct_name/DISABLED";


    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);   

    for $x (0 .. $#groups) {
       $groups[$x] =~ s/\n//g;
       $groups[$x] =~ s/\cM//g;

       $GROUP = "$groups[$x].grp";

       open ("NEW", ">$data_dir/groups/$GROUP.new") || &ERROR("Cannot read $GROUP file!");

       open ("DAT", "$data_dir/groups/$GROUP") || &ERROR("Cannot read $GROUP file!");
           @lines = <DAT>;
       close(DAT);

       for $y (0 .. $#lines) {
          $lines[$y] =~ s/\n//g;
          if ($lines[$y] ne $acct_name) {
              print NEW "$lines[$y]\n";   
          }
       }

       close(NEW);
       rename "$data_dir/groups/$GROUP.new", "$data_dir/groups/$GROUP"; 

    }

    ## Create the account data file
    open ("ACT", "$data_dir/groups/accounts.list") || &ERROR("Cannot Read Accounts File!");
       @accounts=<ACT>;
    close (ACT);

 
    open ("NACT", ">$data_dir/groups/accounts.list") || &ERROR("Cannot Re-Create Accounts File!");
       for $x (0 .. $#accounts) {
          $accounts[$x] =~ s/\n//g;
          if ($accounts[$x] ne $acct_name) {
              print NACT "$accounts[$x]\n";
          }
       }
    close(NACT);

   print "Account Deleted.<HR><BLOCKQUOTE>\n";
   print "All associated files are gone and the database has been updated.\n";
   print "However, the directories could NOT be deleted, and will have to be removed by hand.<BR><BR>\n";
   print "Additionally, you'll have to remove the banner file itself, if it is on this server.\n";

   &List_Accounts;
   exit 0;
}


sub Init_Account {

   $acct_name = $input{'acct_name'};

   print "Content-Type: text/html\n\n";

   opendir(FILES, "$data_dir/accounts/$acct_name/logs");
     @allfiles=readdir(FILES);
   closedir(FILES);           

   for $x ( 0 .. $#allfiles ) {
      if ($allfiles[$x] =~ ".log") {
        unlink "$data_dir/accounts/$acct_name/logs/$allfiles[$x]";
        print "$data_dir/accounts/$acct_name/logs/$allfiles[$x] Deleted.<BR>\n"; 
      }
   }
 
   print "<HR>Re-Initialization Completed.";

   exit 0;
}


sub Disable_Account {

   $acct_name = $input{'acct_name'};

    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);   

    open ("DIS", ">$data_dir/accounts/$acct_name/DISABLED");
    &lock(DIS);

    for $x (0 .. $#groups) {
       $groups[$x] =~ s/\n//g;

       $GROUP = "$groups[$x].grp";
       $exists = "F";

       open ("DAT", "$data_dir/groups/$GROUP");
           @lines = <DAT>;
       close(DAT);

       open ("NGRP",">$data_dir/groups/$GROUP");
       &lock(NGRP);
          for $x ( 0 .. $#lines ) {
              $lines[$x] =~ s/\n//g;
              if ($lines[$x] =~ $acct_name)  {
                 print DIS "$groups[$x]\n";
              }
              else {
                 print NGRP "$lines[$x]\n";
              }
          }
       close(NGRP);
       &unlock(NGRP);
     }
 

     open ("DEF", "$data_dir/groups/default.grp");
         @default = <DEF>;
     close(DEF);

       open ("NDEF",">$data_dir/groups/default.grp");
       &lock(NDEF);
          for $z ( 0 .. $#default ) {
            $default[$z] =~ s/\n//g;
            if ($default[$z] ne $acct_name)  {
               print NDEF "$default[$z]\n";
            }
        }

        close (NDEF);
       &unlock(NDEF);

       print DIS "default\n";
     close (DIS);
     &unlock(DIS);


    
    &List_Accounts; 
  
    exit 0;

}

sub Enable_Account {

   $acct_name = $input{'acct_name'};

    open (DIS, "$data_dir/accounts/$acct_name/DISABLED");
       @disabled=<DIS>;
    close(DIS);

    unlink "$data_dir/accounts/$acct_name/DISABLED" || &ERROR("Cannot Enable Account!");

    for $x (0 .. $#disabled) {
       $GROUP = $disabled[$x];
       $GROUP =~ s/\n//g;
       open("GRP",">>$data_dir/groups/$GROUP.grp");
       &lock(GRP);
           print GRP "$acct_name\n"; 
       close(GRP);
       &unlock(GRP);
    }

    &List_Accounts; 

    exit 0;

}

sub Save_Account_Modification {

    ### Values from input...
    $acct_name       = $input{'acct_name'};
       $acct_name =~ s/ /_/g;

    $acct_login      = $input{'acct_login'};
    $acct_password   = $input{'acct_password'};
    $target          = $input{'target'};
    $redirect_url    = $input{'redirect_url'};
    $alt_text        = $input{'alt_text'};
    $under_text      = $input{'under_text'};
    $banner         = $input{'banner'};
    $banner_width   = $input{'banner_width'};
    $banner_height  = $input{'banner_height'};
    $expiration_type = $input{'expiration_type'};
    $num_clicks      = $input{'num_clicks'};
    $num_impressions = $input{'num_impressions'};
    $start_date      = $input{'start_date'};
    $end_date        = $input{'end_date'};
    $group           = $input{'group'};
       @groups = split(/ /,$group);


    $LINE .= $acct_name . "|";
    $LINE .= $acct_login . "|";
    $LINE .= $acct_password . "|";
    $LINE .= $target . "|";
    $LINE .= $redirect_url . "|";
    $LINE .= $alt_text . "|";
    $LINE .= $under_text . "|";
    $LINE .= $banner . "|";
    $LINE .= $banner_width . "|";
    $LINE .= $banner_height . "|";
    $LINE .= $expiration_type . "|";
    $LINE .= $num_clicks . "|";
    $LINE .= $num_impressions . "|";
    $LINE .= $start_date . "|";
    $LINE .= $end_date;


    ## Re-Create the account data file
    open ("NEW", ">$data_dir/accounts/$acct_name/$acct_name.dat") || &ERROR("Cannot Account Data File!");
       print NEW $LINE;
    close (NEW);

    print "Content-Type: text/html\n\n";
    print "Updated.\n";

    exit 0;



}


###########################################################################
#                 ___         __              _
#                /   |   ____/ / ____ ___    (_) ____
#               / /| |  / __  / / __ `__ \  / / / __ \
#              / ___ | / /_/ / / / / / / / / / / / / / _   _   _
#             /_/  |_| \__,_/ /_/ /_/ /_/ /_/ /_/ /_/ (_) (_) (_)
#
###########################################################################



###########################################################################
###########################################################################
sub bm_admin {


   ### Password Must be OK, Open Frames...

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<frameset cols=\"20%,*\" framespacing=0 frameborder=0 border=0>\n";
    	print "<!-- Left Frame:  Shows Admin Buttons and available forums -->\n";
    	print "<frame name=\"menu\" src=\"bm_admin.cgi?action=menu&password=$password\" ";
	print "border=\"0\" scrolling=\"no\" frameborder=\"0\" framespacing=\"0\" ";
	print "marginwidth=\"0\" marginheight=\"0\" noresize>\n";
	print "<!-- Main Frame, Where you do work...     -->\n";
    	print "<frame name=\"work\" src=\"$html_dir/readme.htm\" border=\"0\" ";
	print "scrolling=\"yes\" frameborder=\"0\" framespacing=\"0\" ";
	print "marginwidth=\"0\" marginheight=\"0\" noresize>\n";
	print "</frameset>\n";
	print "</HTML>\n";


	exit 0;
}


###########################################################################
###########################################################################
## Menu Frame...

sub nav_bar {

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<SCRIPT LANGUAGE=\"javascript\">\n";

  	print 'function ShowHelp() {';
	print "\n";
    	print "   parent.work.document.location.href=\"$manual\";";
	print "\n";
	print "}\n";

	print "</SCRIPT>\n";



	print "<BODY BGCOLOR=\"$pg_color\">\n";
	print "<CENTER>\n";
	print "<P><FONT COLOR=\"$text_color\"><H1>Bannermaster Admin</H1></FONT><P><P>\n";

	print "<FORM ACTION=\"bm_admin.cgi\" TARGET=\"work\" METHOD=\"POST\">\n";
        print "Group Management<BR><SELECT NAME=\"action\">\n";
        print "<OPTION VALUE=\"Define Groups\">Define Groups\n";
        print "<OPTION VALUE=\"Group Manager\">Group Manager\n";
        print "</SELECT>\n";
	print "<INPUT TYPE=\"submit\" VALUE=\"Go\"><BR>\n";

        print "<SELECT NAME=\"group\">\n";
        print "<OPTION VALUE=\"default\">Default Group\n";

        open("GRP","$data_dir/groups/groups.def");
          @groups=<GRP>;
        close(GRP);   
    
        for $x (0 .. $#groups) {
           $groups[$x] =~ s/\n//g;
           print "<OPTION VALUE=\"$groups[$x]\">$groups[$x]\n";
        }
 
        print "</SELECT><P></FORM>\n";

	print "<FORM ACTION=\"bm_admin.cgi\" TARGET=\"work\" METHOD=\"POST\">\n";
        print "Account Management<BR><SELECT NAME=\"action\">\n";
        print "<OPTION VALUE=\"List Accounts\">List Accounts\n";
        print "<OPTION VALUE=\"Add Account\">Add Account\n";
        print "</SELECT>\n";
	print "<INPUT TYPE=\"submit\" VALUE=\"Go\"><P>\n";
        print "</FORM>\n";
        
        print "<FORM>\n";
	print "<INPUT TYPE=\"button\" NAME=\"hlp\" onClick=\"ShowHelp();\" VALUE=\"HELP\"><P>\n";
	print "</FORM>\n";
	print "<CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;
}
