##############################################################################
# CCS CGI Library (iweb.lib)        Version 2.5                              #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# This file (admin.cgi) may be modified only by registered users so long as  #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################


##############################################################################
# You MAY need to change this line to point to the ABSOLUTE PATH to 
# the directory where you have installed "global.cfg"
# If you are keeping global.cfg in the same directory as the iweb.lib 
# library file, and that directory has "write" access, then leave this
# line alone.  Otherwise, you'll need to change it.
# Many servers do not allow writing to files in the /cgi-bin directory
# If this is the case with you, then move global.cfg to another area of
# your web site (Preferably the same directory you have designated to be
# your "data" directory, and change this line accordingly...
##############################################################################


$global_cfg = "./data/global.config";

##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
#                                                                            #
#  PROGRAM: Iweb Library                                                     #
#  VERSION: 5.70                                                             #
##############################################################################

############################################
## Grab Required Modules
############################################
require ($global_cfg);
require ("cgitoolkit.pm");
require ("banners.pm");
require ("custom.pm");

############################################
## What Programs does this user have?
############################################

   $f = "bbs_admin.cgi";
   $k = "gb_admin.cgi";
   $x = "filex_admin.cgi";
   $q = "faq.cgi";
   $s = "splat.cgi";
   $u = "users.cgi";
   $c = "class_admin.cgi";
   $m = "mailman.cgi";
   $y = "hs_admin.cgi";
   $l = "iseek_admin.cgi";
   $k = "ilink_admin.cgi";
   $n = "bm_admin.cgi";
   $t = "top_admin.cgi";
   $d = "todo_admin.cgi";

   if (-e "$f" ) {$BBS="T";}
   if (-e "$k" ) {$GBOOK="T";}
   if (-e "$x" ) {$FILES="T";}
   if (-e "$s" ) {$SPLAT="T";}
   if (-e "$q" ) {$FAQ="T";}
   if (-e "$u" ) {$USERS="T";}
   if (-e "$c" ) {$CLASS="T";}
   if (-e "$m" ) {$MAIL="T";}
   if (-e "$y" ) {$HYPERSEEK="T";}
   if (-e "$k" ) {$ILINK="T";}
   if (-e "$l" ) {$ISEEK="T";}
   if (-e "$n" ) {$BANNERS="T";}
   if (-e "$t" ) {$TOP50="T";}
   if (-e "$d" ) {$TODO="T";}





##############################################################################
#       _       __       _  __          ______          ______ _  __
#      | |     / /_____ (_)/ /_ ___    /_  __/____     / ____/(_)/ /___
#      | | /| / // ___// // __// _ \    / /  / __ \   / /_   / // // _ \
#      | |/ |/ // /   / // /_ /  __/   / /  / /_/ /  / __/  / // //  __/
#      |__/|__//_/   /_/ \__/ \___/   /_/   \____/  /_/    /_//_/ \___/
#
##############################################################################

sub Powered_By {

  print "<BR><BR>\n";
  print "<A HREF=\"http://www.interactive-web.net\" TARGET=\"_blank\">\n";
  print "<IMG SRC=\"$button_dir/iwebbutton.gif\" WIDTH=\"88\" HEIGHT=\"31\" BORDER=0 ALT=\"Powered By Interactive Web CGI Applications\"></A><BR>\n";
  print "Powered By iWeb\n";

}



##############################################################################
#                          __                   _
#                         / /    ____   ____ _ (_)____
#                        / /    / __ \ / __ `// // __ \
#                       / /___ / /_/ // /_/ // // / / /
#                      /_____/ \____/ \__, //_//_/ /_/
#                                    /____/
#
##############################################################################
sub ccs_login {

   local($place_to_go) = @_;

   if ($password eq $admin_pw) {
	&ccs_login_ok($place_to_go);   
   }

   else {
	if ($password eq "") {&ccs_get_login($place_to_go);}
        else {&ccs_bad_login($place_to_go);}
   }

}


sub ccs_get_login {

   local($place_to_go) = @_;

   print "Content-type: text/html\n\n";
   print <<EOLOGIN;
   <HTML>
   <HEAD><TITLE>Admin Logon</TITLE></HEAD>
   <BODY BGCOLOR="white" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF">
   <IMG SRC="http://www.ccs.net/images/ccs_white.jpg">
   <BR><H1></H1>
   <FORM METHOD="post" NAME="logon" ACTION="$place_to_go" ENCTYPE="x-www-form-urlencoded" >
     <CENTER>
     <TABLE width=320 border=1 cellspacing=0 cellpadding=0 bgcolor="#C0C0C0">
       <TR>
       <TD>

         <TABLE width="100%" border=0 cellpadding=0>
         <TR>
           <TD bgcolor="#00007F" colspan=2 height=20>
             <FONT SIZE=-1 COLOR="FFFFFF" FACE="MS Sans Serif"><B>&#160;User Logon</B></FONT>
           </TD>
         </TR>
         <TR>
           <TD align="center" colspan=2><BR>
             <FONT SIZE=-1 COLOR="660000"><B>Please Logon <BR></B></FONT><P>
           </TD>
         </TR>
         <TR>
           <TD align="right">
             <FONT SIZE=-1 FACE="MS Sans Serif"><B>Password:</B></FONT><P>
           </TD>
           <TD>
             <INPUT TYPE="hidden" NAME="action" VALUE="login">
             <INPUT type="password" name="password" maxlength=20><P>
           </TD>
   
         </TR>
       </TABLE>

     <TABLE width="100%" border=0 cellpadding=0>
       <TR>
         <TD align="right" width="50%">
           <INPUT type="submit" value="Login"></FORM></TD><TD align="left"><P>
         </TD>
       </TR>
     </TABLE>

   </TD></TR></TABLE>

   </CENTER>
   <SCRIPT>
   <!--
   document.logon.password.focus()
   // -->
   </SCRIPT>
   </BODY>
   </HTML>

EOLOGIN

exit 0;

}



sub ccs_login_ok {


   local($place_to_go) = @_;

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD>\n";
	print "  <TITLE>Authorization Approved</TITLE>\n";
	print "</HEAD>\n";
        print "<SCRIPT LANGUAGE=\"javascript\">\n";
	print "   self.location.href=\"$place_to_go?action=admin&password=$password\";\n";
	print "</SCRIPT>\n";

	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;

}

sub ccs_bad_login {


   local($place_to_go) = @_;

	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD>\n";
	print "  <TITLE>Authorization Denied</TITLE>\n";
	print "</HEAD>\n";
        print "<SCRIPT LANGUAGE=\"javascript\">\n";
	print "</SCRIPT>\n";
	print "<BODY BGCOLOR=\"silver\">\n";
	print "  <CENTER>\n";
	print "  <H1><FONT COLOR=\"#0000ff\">Login Denied</FONT></H1>\n";
	print "  </CENTER>\n";
	print "</BODY>\n";
	print "</HTML>\n";

	exit 0;

}


##############################################################################
#                     ____         ____               __ __
#                    / __ \ ___   / __/____ _ __  __ / // /_
#                   / / / // _ \ / /_ / __ `// / / // // __/
#                  / /_/ //  __// __// /_/ // /_/ // // /_
#                 /_____/ \___//_/   \__,_/ \__,_//_/ \__/
#
##############################################################################




##############################################################################

##############################################################################
sub ccs_js_array{

	print "function MakeArray(n) {\n";
	print "    this.length = n;\n";
	print "    for (var k = 1;k <= n; k++)\n";
	print "        this[k] = null;\n";
	print "} \n\n";

}


sub Page_Header {

    $GROUP = @_[0];
    $SEARCH = @_[1];


    ## First, Determine which template to use, either the 
    ## current Search Term or Category, if it's defined.

    if ($SEARCH) {
       $FILENAME="$data_dir/templates/search.txt";
    }
    else {
       $FILENAME="$data_dir/templates/$GROUP.txt";

    }

    
    ## Now, if it does not exist,
    ## look for a template for the current category.
    ## If it doesn't exist, get the default.

    if (! -e $FILENAME) {
       $FILENAME="$data_dir/templates/$baseCAT.txt";
    }

    if (! -e $FILENAME) {
       $FILENAME = "$data_dir/templates/default.txt";
    }


    ## Send the HTML Header, and the contents...

    print "Content-Type: text/html\n\n";
    if (-e "$FILENAME") {
      open(HDR,"$FILENAME");
         while(<HDR>) {
             &DoPlugin;
         }
      close(HDR);
    }


    else {
       &Body;
    }

}



sub DoPlugin {

   ## ---------------------------------------------------------------------------------##
   ## Plugin Replacement Area                                                          ##
   ## ---------------------------------------------------------------------------------##

   $line = $_;
   $line =~ s/\cM//g;


   ## ---------------------------------------------------------------------------------##
   ## Standard and Common Plugins                                                      ##
   ## ---------------------------------------------------------------------------------##

   ### ---- MAIN BODY PLUGIN ---- ###
      $pBODY = "PLUGIN:BODY";
      if ($line =~ $pBODY) {
         $line =~ s/$pBODY//g;
         &Body;
      }

   ### ---- Hyperseek Menu PLUGIN ---- ###
      $pMENU = "PLUGIN:MENU";
      if ($line =~ $pMENU) {
         $line =~ s/$pMENU//g;
         &Menu;
      }

   ### ---- Hyperseek Categories PLUGIN ---- ###
      $pCATS = "PLUGIN:CATEGORIES";
      if ($line =~ $pCATS) {
         $line =~ s/$pCATS//g;
         &Categories;
      }


   ### ---- iForums ControlPanel PLUGIN ---- ###
      $pPANEL = "PLUGIN:CONTROL_PANEL";
      if ($line =~ $pPANEL) {
         $line =~ s/$pPANEL//g;
         &Control_Panel;
      }




   ### ---- Todays Date PLUGIN ---- ###
      $pDATE = "PLUGIN:DATE";
      if ($line =~ $pDATE) {
         $pDATE_CODE = &Long_Date(time);
         $line =~ s/$pDATE/$pDATE_CODE/g;
      }

      $pSHORTDATE = "PLUGIN:SHORTDATE";
      if ($line =~ $pSHORTDATE) {
         $pSHORTDATE_CODE = &Short_Date(time);
         $line =~ s/$pSHORTDATE/$pSHORTDATE_CODE/g;
      }

      $pUSDATE = "PLUGIN:USDATE";
      if ($line =~ $pUSDATE) {
         $pUSDATE_CODE = &US_Date(time);
         $line =~ s/$pUSDATE/$pUSDATE_CODE/g;
      }

   ### ---- Referring Link PLUGIN ---- ###
      $pREF = "PLUGIN:REFERER";
      if ($line =~ $pREF) {
         $pREF_CODE = "$ENV{'HTTP_REFERER'}";
         $line =~ s/$pREF/$pREF_CODE/g;
      }


   ### ---- Referring Link PLUGIN ---- ###
      $pBANNER = "PLUGIN:BANNER";
      if ($line =~ $pBANNER) {
         $pBANNER_CODE = &Group_Banner($GROUP);
         $line =~ s/$pBANNER/\n\n <!-- Banner Rotation Start -->\n\n $pBANNER_CODE \n\n <!-- Banner Rotation End -->\n\n /g;
      }


   ## ---------------------------------------------------------------------------------##
   ## Custom Subroutines (User Definedd)                                               ##
   ## ---------------------------------------------------------------------------------##

   ### ---- Referring Link PLUGIN ---- ###
      $pCUSTOM1 = "PLUGIN:CUSTOM1";
      if ($line =~ $pCUSTOM1) {
         $line =~ s/$pCUSTOM1//g;
         &Custom_Function_1;
      }

   ### ---- Referring Link PLUGIN ---- ###
      $pCUSTOM2 = "PLUGIN:CUSTOM2";
      if ($line =~ $pCUSTOM2) {
         $line =~ s/$pCUSTOM2//g;
         &Custom_Function_2;
      }

   ### ---- Referring Link PLUGIN ---- ###
      $pCUSTOM3 = "PLUGIN:CUSTOM3";
      if ($line =~ $pCUSTOM3) {
         $line =~ s/$pCUSTOM3//g;
         &Custom_Function_3;
      }

   ### ---- Referring Link PLUGIN ---- ###
      $pCUSTOM4 = "PLUGIN:CUSTOM4";
      if ($line =~ $pCUSTOM4) {
         $line =~ s/$pCUSTOM4//g;
         &Custom_Function_4;
      }



   ## ---------------------------------------------------------------------------------##
   ## Hyperseek Specific Standard Plugins                                              ##
   ## ---------------------------------------------------------------------------------##

   if ($HYPERSEEK eq "T") {

      ### ---- ADD URL PLUGIN ---- ###
         $pADD = "PLUGIN:ADD_URL";
         if ($line =~ $pADD) {
            $pADD_CODE = "$CGI_DIR/add_url.cgi?action=New&category=$ReqCategory&sub_category=$ReqSubCategory";
            $pADD_CODE =~ s/ /+/g;
            $line =~ s/$pADD/$pADD_CODE/g;
         }
   
      ### ---- TOP 10 LIST PLUGIN ---- ###
         $pTOP = "PLUGIN:TOP10";
         if ($line =~ $pTOP) {
            $pTOP_CODE = "$CGI_DIR/top10.cgi?Category=$ReqCategory|$ReqSubCategory";
            $pTOP_CODE =~ s/ /+/g;
            $line =~ s/$pTOP/$pTOP_CODE/g;
         }
   
      ### ---- Whats New PLUGIN ---- ###
         $pNEW = "PLUGIN:NEW";
         if ($line =~ $pNEW) {
            $pNEW_CODE = "$CGI_DIR/new.cgi";
            $line =~ s/$pNEW/$pNEW_CODE/g;
         }
   
      ### ---- Whats Cool PLUGIN ---- ###
         $pCOOL = "PLUGIN:COOL";
         if ($line =~ $pCOOL) {
            $pCOOL_CODE = "$CGI_DIR/hyperseek.cgi?search=COOL";
            $line =~ s/$pCOOL/$pCOOL_CODE/g;
         }
   
      ### ---- Search BOX PLUGIN ---- ###
         $pSEARCH = "PLUGIN:SEARCH";
         if ($line =~ $pSEARCH) {
            $pSEARCH_CODE = &Search;
            $line =~ s/$pSEARCH/$pSEARCH_CODE/g;
         }
   
   
      ## ---------------------------------------------------------------------------------##
      ## Hyperseek Specific Extra (Fee) Plugins                                              ##
      ## ---------------------------------------------------------------------------------##
   
      ### ---- OPT-IN Mailing List PLUGIN ---- ###
         $pOPTIN = "PLUGIN:OPTIN";
         if ($line =~ $pOPTIN) {
            $pCATEGORY = "$ReqCategory $ReqSubCategory";
            $pCATEGORY =~ s/ /_/g;
            $pCATEGORY =~ s/\+/_/g;
            $pCATEGORY =~ s/\:/_/g;
            $pCATEGORY =~ s/\//_/g;
            $pCATEGORY =~ s/\&/_/g;
   
            if ( -e "optin.cgi" ) {
               $pOPTIN_CODE =  "<FORM ACTION=\"$CGI_DIR/optin.cgi\" METHOD=\"POST\"><INPUT TYPE=\"hidden\" NAME=\"list\" VALUE=\"$pCATEGORY\">\n";
               $pOPTIN_CODE .= "<INPUT TYPE=\"text\" SIZE=\"15\" NAME=\"email\" VALUE=\"Email Address\">\n";
               $pOPTIN_CODE .= "<INPUT TYPE=\"submit\" VALUE=\"Add Me\"></FORM>\n";
            }
            else {
               $pOPTIN_CODE = "";
            }

            $line =~ s/$pOPTIN/$pOPTIN_CODE/g;
         }
   
   
      ### ---- CHAT PLUGIN ---- ###
         $pCHAT = "PLUGIN:CHAT";
         if($line =~ $pCHAT) {
            $pCHATROOM = "$ReqCategory\:\:$ReqSubCategory";
            $pCHATROOM =~ s/\+/ /g; 
           
            if ( -e "java/GroupServer.class" ) {
               $pCHAT_CODE = "$CGI_DIR/chat.cgi?room=$pCHATROOM";
            }
            else {
               $pCHAT_CODE = "";
            }
          
            $line =~ s/$pCHAT/$pCHAT_CODE/g;
         } 
   
   
      ### ---- BBS PLUGIN ---- ###
      $pBBS = "PLUGIN:FORUM";
         if($line =~ $pBBS) {
   
            $tempFORUM = "$ReqCategory:$ReqSubCategory";
            $tempFORUM =~ s/ /_/g;
            $tempFORUM =~ s/\+/_/g;
            $tempFORUM =~ s/\//_/g;
            $tempFORUM =~ s/\&/_/g;
            @forum = split(/\:/, $tempFORUM);
         
            $forum_ok = "F";
            if($yh_forums eq "MAIN") {
               if($forum[0]) {
                  $pFORUM = "$forum[0]";
                  $pFORUM =~ s/ /_/g;
                  $forum_ok = "T";
               }
            }
            
            if ($yh_forums eq "CATEGORY") {
               if($forum[1]) {
                  $pFORUM = "$forum[0]_$forum[1]";
                  $pFORUM =~ s/ /_/g;
                  $forum_ok = "T";
               }
            }
      
            if ($yh_forums eq "ALL") {
               if($forum[1]) {
                  $pFORUM = $tempFORUM;
                  $pFORUM =~ s/ /_/g;
                  $pFORUM =~ s/\:/_/g;
                  $forum_ok = "T";
               }
            }
   
            if ( (-e "users.cgi" ) && $forum_ok eq "T") {
               $pBBS_CODE = "<FORM ACTION='$CGI_DIR/users.cgi' METHOD='POST'>\n";
               $pBBS_CODE .= "<INPUT TYPE=\"hidden\" NAME=\"forum\" VALUE=\"$pFORUM\">\n"; 
               $pBBS_CODE .= "<INPUT TYPE=\"submit\" VALUE=\"Open Forum\">\n"; 
               $pBBS_CODE .= "</FORM>\n";
      
            }
            else {
               $pBBS_CODE = "";
            }

            $line =~ s/$pBBS/$pBBS_CODE/g;

         }
   
   
      ### ---- CLASSIFIEDS PLUGIN ---- ###
         $pCLASS = "PLUGIN:CLASSIFIEDS";

         if ($line =~ $pCLASS) {

            $pCLASSCAT = "$ReqCategory\:\:$ReqSubCategory";
   
            open("DAT","$data_dir/classifieds/classifieds.dat");
                @CLASS=<DAT>;
            close(DAT);
            $class_ok = "F";
            for $c(0 .. $#CLASS) {
               $CLASS[$c] =~ s/\n//g;
               $CLASS[$c] =~ s/\cM//g;
               @LINE = split(/\|/,$CLASS[$c]);
               if ($LINE[1] eq $pCLASSCAT) { 
                   $CLASS_CAT = $LINE[0];
                   $class_ok = "T";
                   last;
               }
            }

            if ( -e "classifieds.cgi" && $class_ok eq "T") {
               $pCLASS_CODE = "$CGI_DIR/classifieds.cgi?category=$CLASS_CAT";
            }
            else {
               $pCLASS_CODE = "$CGI_DIR/hyperseek.cgi";
            }
      
            $line =~ s/$pCLASS/$pCLASS_CODE/g;
        }

   
   
   }

   ### End Hyperseek Only Loop.

   print $line;

}



1;
