#!/usr/local/bin/perl
##############################################################################
# YooHoo Search Engine (yoohoo.cgi)                                          #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The YooHoo Engine, which includes all files in the origninal distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
# __________________________________________________________________________ #


require("iweb.pm"); 
&parse_form;

$PROGRAM="Bannermaster";
$VERSION="1.25";

$ACCOUNT = $input{'account'};

   if ( $ENV{'HTTP_REFERER'} ) { $REF=$ENV{'HTTP_REFERER'}; }
   else { $REF=$SELF; }

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   ## Log the Click / Referring Page
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $month = $mon+1;
   $name = "$month" . "_" . "$mday" . "_" . "$year.clicks";
   $TIME=time;
   $filename = "$data_dir/accounts/$ACCOUNT/logs/$name";

   open("LOG",">>$filename");
   &lock(LOG);
      print LOG "$TIME|$REF|click\n";
   close(LOG);
   &unlock(LOG);

   $tot_file = "$data_dir/accounts/$ACCOUNT/$ACCOUNT.total";
   open("TOT1","$tot_file");
      @entries=<TOT1>;
   close(TOT1);
   $entries[0] =~ s/\n//g;
   @totals = split(/\|/,$entries[0]);
   $impressions = $totals[0];
   $clicks = $totals[1];
   $NewClicks = $clicks + 1;

   open("TOT",">$tot_file");
   &lock(TOT);
      print TOT "$impressions|$NewClicks";
   close(TOT);
   &unlock(TOT);
 
   $lines[0] =~ s/\n//g;

   ($acct_name,$acct_login,$acct_password,$target,$redirect_url,$alt_text,$under_text,$banner,$banner_width,$banner_height,$expiration_type,$num_clicks,$num_impressions,$start_date,$end_date) = split(/\|/,$lines[0]);


   print "Location: $redirect_url\n\n";


   if ($expiration_type eq "clicks" && $NewClicks >= $num_clicks) { &Disable_Account; }


   exit 0;



sub Disable_Account {

    open("GRP","$data_dir/groups/groups.def");
      @groups=<GRP>;
    close(GRP);   

    open ("DIS", ">$data_dir/accounts/$acct_name/DISABLED");
    &lock(DIS);

    for $x (0 .. $#groups) {
       $groups[$x] =~ s/\n//g;

       $GROUP = "$groups[$x].grp";
       $exists = "F";

       open ("DAT", "$data_dir/groups/$GROUP");
           @lines = <DAT>;
       close(DAT);

       open ("NGRP",">$data_dir/groups/$GROUP");
       &lock(NGRP);
          for $x ( 0 .. $#lines ) {
              $lines[$x] =~ s/\n//g;
              if ($lines[$x] =~ $acct_name)  {
                 print DIS "$groups[$x]\n";
              }
              else {
                 print NGRP "$lines[$x]\n";
              }
          }
       close(NGRP);
       &unlock(NGRP);
     }
 

     open ("DEF", "$data_dir/groups/default.grp");
         @default = <DEF>;
     close(DEF);

       open ("NDEF",">$data_dir/groups/default.grp");
       &lock(NDEF);
          for $z ( 0 .. $#default ) {
            $default[$z] =~ s/\n//g;
            if ($default[$z] ne $acct_name)  {
               print NDEF "$default[$z]\n";
            }
        }

        close (NDEF);
       &unlock(NDEF);

       print DIS "default\n";
     close (DIS);
     &unlock(DIS);


    
    &List_Accounts; 
  
    exit 0;

}
