#!/usr/local/bin/perl
##############################################################################
# YooHoo Search Engine (yoohoo.cgi)    Verison 1.3                           #
# Copyright 2000 John Cokos     jcokos@ccs.net                               #
# Created 05/01/2000            Last Modified 05/16/2000                     #
# Script Home Page:            http://www.interactive-web.net                #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 John C. Cokos      All Rights Reserved.                     #
#                                                                            #
# The YooHoo Engine, which includes all files in the origninal distribution  #
# may be modified only by registered users so long as...                     #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify John C. Cokos from any liability that          #
# might arise from it's use.                                                 #
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#  _                           _   _                                         #
# | \ _  ._  __|_ |\/| _  _|o_|_  |_) _ | _      _|_|_ o _ ._  _ o.__|_ |    #
# |_/(_) | |(_)|_ |  |(_)(_|| |\/ |_)(/_|(_)\/\/  |_| ||_> |_)(_)|| ||_ o    #
#                              /                           |                 #
# __________________________________________________________________________ #


require("iweb.pm"); 
&parse_form;


$ACCOUNT = $input{'account'};
$rpt_date = $input{'date'};
$MODE = $input{'MODE'};

$VERSION = "1.25";
$PROGRAM = "Bannermaster Reports";

if ($MODE ne "admin") { &Do_Login; }
else { &Do_Admin; }


exit 0;

##############################################################################
#  Show a banner for a specific account
##############################################################################

sub Report_Account {

   $imp_referer={};
   $clk_referer={};
   $totals={};

   $clk_count = 0;
   $tot_count = 0;
   $imp_count = 0;

   print "Content-Type: text/html\n\n";

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   $tot_file = "$data_dir/accounts/$ACCOUNT/$ACCOUNT.total";
   open("TOT1","$tot_file");
      @entries=<TOT1>;
   close(TOT1);
   $entries[0] =~ s/\n//g;
   @totals = split(/\|/,$entries[0]);
   $impressions = $totals[0];
   $clicks = $totals[1];


   $log_dir = "$data_dir/accounts/$ACCOUNT/logs";
   opendir(FILES, "$log_dir") || die ERROR("Can't open log directory ($log_dir) <BR><BR>");
     @filelist=readdir(FILES);
   closedir(FILES);

    for $z( 0 .. $#filelist ) {

        $file = $filelist[$z];
        $filebase = $filelist[$z];
        $date = $filelist[$z];
        $filebase =~ s/\.log//g;
        $filebase = "$data_dir/accounts/$ACCOUNT/logs/$filebase";
        $date =~ s/\.log//g;
        $date =~ s/_/\//g;

        if($file =~ /.*\.log/ ) {

           ### Tally the daily impressions ###
           open ("LOG","$filebase.log") || &ERROR("Cant open $filebase.log");
              @log=<LOG>;
           close(LOG);

           open ("CLK","$filebase.clicks");
              @clk=<CLK>;
           close(CLK);

           if ($#clk < 0) { $tot_clicks = 0; }
           else { $tot_clicks = $#clk + 1; }
           @{$totals[$tot_count++]}{qw( date impressions clicks )}=
             ( $date, $#log +1, $tot_clicks ); 

        }

    }
      
       $acct_name =~ s/_/ /g;
       print "<CENTER><H1>Advertising Report .... $acct_name</H1>\n";
       print "<H3>Grand Total: $impressions Impressions / $clicks Clicks\n";

          if ( $impressions <= 0 ) { $impressions = 1; }
          $pct = $clicks / $impressions;
          $pct = $pct*100;
          printf ("( %2.2f \% )\n", $pct);
        
       print "</H3>\n";
       print "<BLOCKQUOTE>\n";
       print "<H4>Daily Totals:</H4>\n";
       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Date</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Impressions</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">Clicks</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\">PCT</TD></TR>\n";

       for $t( 0 .. $#totals ) {
          $date = $totals[$t]{'date'};
          $date =~ s/\//_/g;
          $link = "$CGI_DIR/report.cgi?account=$ACCOUNT&action=detail&date=$date&login_id=$login&password=$password";
          print "<TR BGCOLOR=\"$win_color\">\n";
          print "<TD><center><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
          print "  <a href=\"$link\">$totals[$t]{'date'}</a></center></TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'impressions'}</TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'clicks'}</TD>\n";
 
          if ( $totals[$t]{'impressions'} <= 0 ) { $totals[$t]{'impressions'} = 1; }
          $pct = $totals[$t]{'clicks'} / $totals[$t]{'impressions'};
          $pct = $pct*100;
          if ($pct > 1.5) { $pct_color = "blue"; }
          elsif ($pct >= .6 ) { $pct_color = "$text_color"; }
          else { $pct_color="red"; }

          printf ("<TD><FONT FACE=\"$font_face\" COLOR=\"$pct_color\">%2.2f \%</TD></TR>\n", $pct);
       }
       print "</TABLE>\n";
       print "</TD></TR></TABLE>\n";



    exit 0;

}

sub Account_Detail {

   $imp_referer={};
   $clk_referer={};
   $totals={};

   $clk_count = 0;
   $tot_count = 0;
   $imp_count = 0;

   $acct_name = $ACCOUNT;
   $acct_name =~ s/_/ /g;

   print "Content-Type: text/html\n\n";

   open ("ACCT", "$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @lines = <ACCT>;
   close(ACCT);

   $click_file = "$data_dir/accounts/$ACCOUNT/logs/$rpt_date.clicks";

   ### Tally the daily clicks ###
   open ("CLK","$click_file") || &ERROR("Cant open $click_file");
        @clicks=<CLK>;
   close(CLK);

           for $k ( 0 .. $#clicks ) {
              $clicks[$k] =~ s/\n//g;
              @lines = split(/\|/,$clicks[$k]);
              $time = $lines[0];
              $page = $lines[1];
              $source = $lines[2];

              @{$clk_referer[$clk_count++]}{qw( date page )}=
                 ( $date, $page );
           }



       @clicks = sort { $a->{'page'} <=> $b->{'page'} } @clk_referer; 

       for $x ( 0 .. $#clicks ) {
          $DoneWithThisOne = "F";
          $ThisPage = $clicks[$x]{'page'};
          if ($#totals >= 0) {
            for $t (0 .. $#totals) {


                if ($totals[$t]{'page'} eq $ThisPage) {
                    $totals[$t]{'clicks'}++;
                    $DoneWithThisOne = "T";
                }
            }

            if ($DoneWithThisOne ne "T") {
                @{$totals[$tot_count++]}{qw( date page clicks )}=
                 ( $date, $ThisPage, 1 );
            }
            $DoneWithThisOne = "F";

          }

          else {
             @{$totals[$tot_count++]}{qw( date page clicks )}=
              ( $date, $ThisPage, 1 );
          }

       } 


       ## This for readability only ...
       for $t (0 .. $#totals) {
           if ($totals[$t]{'page'} eq "") {
               $totals[$t]{'page'} = "NO Referring Page (Internal)"; 
           }
       }

       $acct_name =~ s/_/ /g;
       print "<CENTER><H1>Detail Report (Clicks).... $acct_name</H1>\n";

       print "<TABLE BORDER=1><TR><TD>\n";
       print "<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=5>\n";
       print "<TR BGCOLOR=\"$title_color\">\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\"><CENTER><U>Page</TD>\n";
       print "<TD><FONT COLOR=\"$ttxt_color\" FACE=\"$font_face\"><CENTER><U>Clicks</TD></TR>\n";

       for $t( 0 .. $#totals ) {
          $date = $totals[$t]{'date'};
          $date =~ s/\//_/g;
          $link = "$CGI_DIR/report.cgi?account=$ACCOUNT&rpt_type=detail&date=$date";
          print "<TR BGCOLOR=\"$win_color\">\n";
          print "<TD><center><FONT FACE=\"$font_face\" COLOR=\"$text_color\">\n";
          print "  <a href=\"$totals[$t]{'page'}\">$totals[$t]{'page'}</a></center></TD>\n";
          print "<TD><FONT FACE=\"$font_face\" COLOR=\"$text_color\">$totals[$t]{'clicks'}</TD></TR>\n";
 
       }

       print "</TABLE>\n";
       print "</TD></TR></TABLE>\n";


   exit 0;
}


sub GetLogin {


    print "Content-Type: text/html\n\n";

    print <<DONE;

	<HTML>
	<HEAD>
	  <TITLE>Bannermaster Login</TITLE>
	</HEAD>
        <BODY BGCOLOR=\"$pg_color\">
        <CENTER>
        <BR><BR><BR>
        <TABLE BORDER=2 CELLSPACING=0 CELLPADDING=0>
          <TR><TD> 

        <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
          <TR><TD> 
            <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
               <TR BGCOLOR="$title_color"><TD> 
               <FONT FACE="$font_face" COLOR="$ttxt_color" SIZE=+1>Enter Login Information
            </TD><TR></TABLE>
          </TD></TR>

          <TR><TD> 
            <TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%"><TR BGCOLOR="$win_color"><TD> 
              <FONT COLOR="$text_color"><FORM ACTION="$CGI_DIR/report.cgi" METHOD="post">
              <PRE>
     Account Name: <INPUT NAME="account">
     Login Name  : <INPUT NAME="login_id">
     Password    : <INPUT TYPE="password" NAME="password"></PRE>
            <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Login"></CENTER></FORM>
            </TD><TR></TABLE>

        </TD><TR></TABLE>
        </TD><TR></TABLE>
	</BODY>
	</HTML>
DONE

    exit 0;
}



sub Do_Login {

   # Open the account's .dat file and validate the username / password
   $login = $input{'login_id'};
   $password = $input{'password'};

   if ( ! $login ) {

       &GetLogin;
       exit 0;
   }
 
   open ("DAT","$data_dir/accounts/$ACCOUNT/$ACCOUNT.dat");
       @account_info=<DAT>;
   close("DAT");

   $account_info[0] =~ s/\n//g;

   ($acct_name,$acct_login,$acct_password,$target,$redirect_url,$alt_text,$under_text,$banner,$banner_width,$banner_height,$expiration_type,$num_clicks,$num_impressions,$start_date,$end_date) = split(/\|/,$account_info[0]);

   if ( $login eq $acct_login && $password eq $acct_password ) { 
        $action = $input{'action'};
          if ($action eq "detail") { &Account_Detail; }
          else { &Report_Account; }
   }
   else { &GetLogin; }

}


sub Do_Admin {


        $action = $input{'action'};
          if ($action eq "detail") { &Account_Detail; }
          else { &Report_Account; }

        exit 0;

}
